(function($) {
    $(document).ready(function () {

        $(document).on('click', '.ctpt-tab', function(e){
            e.preventDefault();
            var self = $(this), tabsContentLevel = self.closest('nav').data('tabs-content-level');
            self.parent().find('.ctpt-tab').removeClass('nav-tab-active');
            self.addClass('nav-tab-active');

            $('.ctpt-tab-content-' + tabsContentLevel).hide();
            $('#' + self.data('tab-content-id')).show();
        });

        $('#ctpt_auth_logout').click(function(e){
            if (!confirm('Удалить ключ? Это обнулит текущие настройки модуля.')) {
                e.preventDefault();
                return false;
            }
        })

        $('#ctpt_operators_upd').click(async function(e){
            e.preventDefault();
            let headers = new Headers();
            headers.append('X-WP-Nonce', $(this).attr('k'));
            const response= await fetch('/?rest_route=/catapultodelivery/opsync', {
                method: 'POST',
                headers: headers,
                body: null,
            }),res = await response.json();

            if (res.res) {
                $('#ctpt_operators_upd_txt').addClass('g').html('Операторы успешно загружены.');
                setTimeout( ()=>{
                    window.location.reload();
                }, 5000 );
            }
            if (typeof(res.error) == 'string') {
                $('#ctpt_operators_upd_txt').css('display','block').addClass('r').html(res.error);
            }
        });

        $('.ctpt_op_element').each( function(){
            let t=$(this);
            if (t.find('select option:selected').attr('value') == 'door') t.find('input').val('').css('display','none');
        });

        $('.ctpt_op_element select').change( function(){
            let t=$(this);
            if (t.find('option:selected').attr('value') == 'door') {
                t.next().val('').css('display','none');
            } else {
                t.next().css('display','');
            }
        } );

        $('#ctpt_op_setalldoors').click(function(e){
            e.preventDefault();

            $('.ctpt_op_element select option').removeAttr('selected');
            $('.ctpt_op_element').each( function() {
                let t=$(this);
                t.find('select option[value=door]').prop('selected', true);
                t.find('input').val('').css('display','none');
            } );
            $('button[name=save]').removeAttr('disabled');

            return false;
        });
        $('#ctpt_op_setallwh').click(function(e){
            e.preventDefault();

            $('.ctpt_op_element select option').removeAttr('selected');
            $('.ctpt_op_element').each( function() {
                let t=$(this);
                t.find('select option[value=warehouse]').prop('selected', true);
                t.find('input').css('display','');
            } );
            $('button[name=save]').removeAttr('disabled');

            return false;
        });

        function numberValidator(input, validator = /^([0-9]){0,6}$/) {
            let vl = input.value;
            while (!validator.test(vl)) {
                vl = vl.slice(0,-1);
                if (vl=='') break;
            }
            vl = vl.replace(',','.');
            input.value = vl;
        }

        $('#woocommerce_catapultodelivery_defaultWidth').keyup(function(){
            numberValidator(this);
        });
        $('#woocommerce_catapultodelivery_defaultHeight').keyup(function(){
            numberValidator(this);
        });
        $('#woocommerce_catapultodelivery_defaultLength').keyup(function(){
            numberValidator(this);
        });
        $('#woocommerce_catapultodelivery_defaultWeight').keyup(function(){
            numberValidator(this);
        });

        $('#woocommerce_catapultodelivery_deliveryDefaultPrice').keyup(function(){
            numberValidator(this, /^([0-9]){0,6}(\.|\,){0,1}([0-9]){0,2}$/);
        });
        $('#woocommerce_catapultodelivery_termIncrease').keyup(function(){
            numberValidator(this, /^([0-9]){0,2}$/);
        });

        $('#woocommerce_catapultodelivery_freeDlvMinCourier').keyup(function(){
            numberValidator(this, /^([0-9]){0,6}(\.|\,){0,1}([0-9]){0,2}$/);
        });
        $('#woocommerce_catapultodelivery_freeDlvMinPVZ').keyup(function(){
            numberValidator(this, /^([0-9]){0,6}(\.|\,){0,1}([0-9]){0,2}$/);
        });

        if (document.querySelector('#woocommerce_catapultodelivery_geoEmptyMessage') !== null)
        document.querySelector('#woocommerce_catapultodelivery_geoEmptyMessage').onkeyup = function(e) {
            const t = this;
            if (t.value.length > 300) t.value = t.value.substring(0, 300);
        }


    });
})(jQuery);
