const cseWarnMsg = document.querySelector('.ctpt_cse_warn'),
    suid = window.ctptData.suid,
    orderId = window.ctptData.orderId,
    operator = window.ctptData.operator,
    goodsPrice = window.ctptData.goodsPrice,
    shippingPrice = window.ctptData.shippingPrice,
    isCod = window.ctptData.isCod,
    codAmount = window.ctptData.codAmount,
    isInsured = window.ctptData.isEnsurance,
    isCSE = operator === 'cse';

if (isCSE) cseWarnMsg.classList.remove('hide');
let headers = new Headers();
headers.append('X-WP-Nonce', suid);

const sendOrder = async e => {
    e.preventDefault();

    if (document.querySelector('input[name=ctpt_buyerZip]').value.length < 4) {
        alert('Необходимо указать индекс города получения');
        return false;
    }
    if (document.querySelector('input[name=ctpt_buyerStreet]').value.length < 2) {
        alert('Необходимо указать улицу получателя');
        return false;
    }
    if (document.querySelector('input[name=ctpt_buyerBuilding]').value.length == 0) {
        alert('Необходимо указать дом получателя');
        return false;
    }

    let frm = new FormData();
    frm.append('orderId', orderId);
    frm.append('ctpt_buyerName', document.querySelector('input[name=ctpt_buyerName]').value);
    frm.append('ctpt_buyerPhone', document.querySelector('input[name=ctpt_buyerPhone]').value);
    frm.append('ctpt_buyerEmail', document.querySelector('input[name=ctpt_buyerEmail]').value);
    frm.append('ctpt_buyerCompany', document.querySelector('input[name=ctpt_buyerCompany]').value);
    frm.append('ctpt_buyerZip', document.querySelector('input[name=ctpt_buyerZip]').value);
    frm.append('ctpt_buyerCity', document.querySelector('input[name=ctpt_buyerCity]').value);
    frm.append('ctpt_buyerStreet', document.querySelector('input[name=ctpt_buyerStreet]').value);
    frm.append('ctpt_buyerBuilding', document.querySelector('input[name=ctpt_buyerBuilding]').value);
    frm.append('ctpt_buyerDoorNumber', document.querySelector('input[name=ctpt_buyerDoorNumber]').value);
    frm.append('ctpt_comment', document.querySelector('textarea[name=ctpt_comment]').value);
    frm.append('ctpt_needInsurance', document.querySelector('input[name=ctpt_needInsurance]').checked ? 'Y' : 'N' );
    frm.append('ctpt_insuranceValue', document.querySelector('input[name=ctpt_insuranceValue]').value);
    frm.append('ctpt_isBeznal', document.querySelector('input[name=ctpt_isBeznal]').checked ? 'Y' : 'N' );
    frm.append('ctpt_sumToPay', document.querySelector('input[name=ctpt_sumToPay]').value);
    frm.append('ctpt_deliveryPaySide', document.querySelector('input[name=ctpt_deliveryPaySide]').checked ? 'Y' : 'N' );

    const response= await fetch('/?rest_route=/catapultodelivery/ordersend', {
        method: 'POST',
        headers: headers,
        body: frm,
    }), res = await response.json();
    if (res.res) window.location.reload();
    else alert("При отправке заявки произошла ошибка.\n"+res.error);
}

const renewOrder = async e => {
    e.preventDefault();

    let frm = new FormData();
    frm.append('orderId', orderId);
    frm.append('catapultoOrderKey', catapultoOrderKey);

    const response= await fetch('/?rest_route=/catapultodelivery/orderrenew', {
        method: 'POST',
        headers: headers,
        body: frm,
    }), res = await response.json();

    if (res.res) window.location.reload();
    else alert("При отправке заявки произошла ошибка.\n"+res.error);
}

const sendVariant = async variantData => {
    window.CatapultoWidget.hide();
    variantData['dadata'] = window.CatapultoWidget.getData().getVariant();
    variantData['rate_param'] = window.CatapultoWidget.getData().RateParams;

    let frm = new FormData();
    frm.append('data', JSON.stringify(variantData));
    const response = await fetch('/?rest_route=/catapultodelivery/reselectrate',{
        method: 'POST',
        headers: headers,
        body: frm,
    }), res = await response.json();

    if (res.res) window.location.reload();
    else console.log('updRateError', res);
};

const selectCourierItem = Item => {
    if (Item && typeof (Item.variant.id) !== 'undefined') {
        Item['ctpt_params'] = {
            rate_type: 'courier',
            order_id: orderId,
            isEmpty: false,
        };
        sendVariant(Item);
    }
}

const selectPVZItem = Item => {
    if (Item && (typeof(Item.Variant) !== 'undefined')) {
        Item['ctpt_params'] = {
            rate_type: 'pvz',
            order_id: orderId,
            isEmpty: false,
        };
        if (typeof(Item['Variant']) !== 'undefined') {
            Item['variant'] = Item['Variant'];
            delete Item['Variant'];
        }
        sendVariant(Item);
    }
}

document.querySelector('#ctpt_reselect').onclick = e => {
    e.preventDefault();
    window.Ctpt_widgetParams.onSelectPvzItem = selectPVZItem;
    window.Ctpt_widgetParams.onSelectCourierItem = selectCourierItem;
    window.Ctpt_widgetParams.need_insurance = document.getElementById('ctpt_needInsurance').checked;
    window.Ctpt_widgetParams.insured_value = Number(document.getElementById('ctpt_insuranceValue').value);
    if (isNaN(window.Ctpt_widgetParams.insured_value)) window.Ctpt_widgetParams.insured_value = 0;
    if (!window.CatapultoWidget) {
        window.CatapultoWidget = new CatapultoWidget2(window.Ctpt_widgetParams);
    } else {
        if (typeof(window.CatapultoWidget.destroy) === "function") window.CatapultoWidget.destroy();
        delete window.CatapultoWidget;
        window.CatapultoWidget = new CatapultoWidget2(window.Ctpt_widgetParams);
    }
    window.CatapultoWidget.show();
}

const onInsuranceChange = () => {
    const
        needInsurance = document.getElementById('ctpt_needInsurance'),
        insuranseVal = document.getElementById('ctpt_insuranceValue');

    if (needInsurance.checked) insuranseVal.readOnly = false;
    else insuranseVal.readOnly = true;
    onPayChange(false);
}
const onDeliveryPaySideChange = () => {
    const paySide = document.getElementById('ctpt_deliveryPaySide');
    if (paySide.checked && paySide.disabled) paySide.checked = false;
    if (paySide.checked) onPayChange();
    else document.getElementById('ctpt_sumToPay').value = goodsPrice;
}

const onPayChange = (changeDeliveryPaySide = true) => {
    const
        needInsurance = document.getElementById('ctpt_needInsurance'),
        isBeznal = document.getElementById('ctpt_isBeznal'),
        paySide = document.getElementById('ctpt_deliveryPaySide'),
        toPay = document.getElementById('ctpt_sumToPay');

    if (isBeznal.checked) {
        toPay.value = '0';

        paySide.checked = false;
        paySide.disabled = true;

        if (isCSE) cseWarnMsg.classList.add('hide');
    } else {
        let insuranseValue = Number(document.getElementById('ctpt_insuranceValue').value),
            sumToPay = parseFloat(goodsPrice);
        if (isNaN(insuranseValue)) insuranseValue = 0;
        const insValue = Math.ceil(parseFloat(insuranseValue) * 0.01);
        if (parseFloat(shippingPrice) == 0) {
            paySide.checked = false;
            changeDeliveryPaySide = false;
            paySide.disabled = true;
        }
        if ( changeDeliveryPaySide || paySide.checked ) {
            if ( !isInsured && needInsurance.checked ) sumToPay += insValue;
            if ( isInsured && !needInsurance.checked ) sumToPay -= insValue;

            sumToPay += parseFloat(shippingPrice);
        }
        toPay.value = sumToPay;
        if (changeDeliveryPaySide || parseFloat(shippingPrice) > 0) {
            paySide.checked = true;
            paySide.disabled = false;
        }
        if (isCSE) cseWarnMsg.classList.remove('hide');
    }

}

document.getElementById('ctpt_sendorder').onclick = sendOrder;
document.getElementById('ctpt_needInsurance').onchange = onInsuranceChange;
document.getElementById('ctpt_deliveryPaySide').onchange = onDeliveryPaySideChange;
document.getElementById('ctpt_isBeznal').onchange = onPayChange;
onPayChange();

if (window.ctptData.isEnsurance) {
    document.getElementById('ctpt_needInsurance').checked = true;
} else {
    document.getElementById('ctpt_insuranceValue').readOnly = true;
}
