jQuery(function(){

    function selectPVZItem(Item) {
        if (Item && (typeof(Item.Variant) !== 'undefined')) {
            Item['ctpt_params'] = {
                rate_type: 'pvz',
                order_id: 0,
                isEmpty: false,
                insurance: window.Ctpt_widgetParams.need_insurance,
            };
            if (typeof(Item['Variant']) !== 'undefined') {
                Item['variant'] = Item['Variant'];
                delete Item['Variant'];
            }
            sendVariant(Item);
        }
    }
    function selectCourierItem(Item) {
        if (Item && typeof (Item.variant.id) !== 'undefined') {
            Item['ctpt_params'] = {
                rate_type: 'courier',
                order_id: 0,
                isEmpty: false,
                insurance: window.Ctpt_widgetParams.need_insurance,
            };
            sendVariant(Item);
        }
    }
    async function sendVariant(variantData){
        window.CatapultoWidget.hide();
        variantData['dadata'] = window.CatapultoWidget.getData().getVariant();
        variantData['rate_param'] = window.CatapultoWidget.getData().RateParams;

        const frm = new FormData();
        frm.append('ctpt_ratedata', JSON.stringify(variantData));
        const response = await fetch('/?rest_route=/catapultodelivery/wpold_ctptsave', {
            method: 'POST',
            body: frm,
        }), dat = await response.json();

        jQuery('#ctpt_selected_rate').val(variantData.variant.id);
        jQuery('#ctpt_changed_ps').val('false');

        //setAddress
        if (
            variantData['dadata'].data.city != null
            && variantData['dadata'].data.city.length > 2
        ) jQuery('#billing_city').val(variantData['dadata'].data.city);
        if (
            variantData['dadata'].data.region_with_type != null
            && variantData['dadata'].data.region_with_type.length > 2
        ) jQuery('#billing_state').val(variantData['dadata'].data.region_with_type);
        if (
            variantData['dadata'].data.postal_code != null
            && variantData['dadata'].data.postal_code.length > 2
        ) jQuery('#billing_postcode').val(variantData['dadata'].data.postal_code);

        let streetaddr = '';
        if (
            variantData['dadata'].data.street_with_type != null
            && variantData['dadata'].data.street_with_type.length > 2
        ) {
            streetaddr += variantData['dadata'].data.street_with_type;
        }
        if (
            streetaddr != ''
            && variantData['dadata'].data.house_type != null
            && variantData['dadata'].data.house_type.length > 0
            && variantData['dadata'].data.house	!= null
            && variantData['dadata'].data.house.length > 0
        ) {
            streetaddr += ', ' + variantData['dadata'].data.house_type + ' ' + variantData['dadata'].data.house;
        }
        if (
            streetaddr != ''
            && variantData['dadata'].data.flat_type != null
            && variantData['dadata'].data.flat_type.length > 0
            && variantData['dadata'].data.flat != null
            && variantData['dadata'].data.flat.length > 0
        ) {
            streetaddr += ', ' + variantData['dadata'].data.flat_type + ' ' + variantData['dadata'].data.flat;
        }

        if (streetaddr.length > 0) jQuery('#billing_address_1').val(streetaddr);

        setTimeout(function(){
            jQuery(document.body).trigger('update_checkout', {
                clear: false
            });
        },1000);
    };

    window.Ctpt_RunWidget = function runWidget() {
        if (typeof(window.Ctpt_widgetParams) === 'undefined') return false;

        window.Ctpt_widgetParams.onSelectPvzItem = selectPVZItem;
        window.Ctpt_widgetParams.onSelectCourierItem = selectCourierItem;
        window.Ctpt_widgetParams.location.address = '';

        const shippingCity = jQuery('#shipping_city').val();
        let city = jQuery('#billing_city').val();
        if (city == '' && shippingCity != '') city = shippingCity;

        const shippingRegion = jQuery('#shipping_state').val();
        let region = jQuery('#billing_state').val();
        if (region == '' && shippingRegion != '') region = shippingRegion;
        if (region.length > 2) window.Ctpt_widgetParams.location.address = region + ', ';

        window.Ctpt_widgetParams.location.address += city;

        if (!window.CatapultoWidget) {
            window.CatapultoWidget = new CatapultoWidget2(window.Ctpt_widgetParams);
        } else {
            if (typeof(window.CatapultoWidget.destroy) === 'function') window.CatapultoWidget.destroy();
            delete window.CatapultoWidget;
            window.CatapultoWidget = new CatapultoWidget2(window.Ctpt_widgetParams);
        }
        window.CatapultoWidget.show();
    }

    jQuery(document).on('click', '#ctpt_runwidget', function(e){
        e.preventDefault();
        window.Ctpt_RunWidget();
    })

    jQuery(document).on('change', '#payment input[name=payment_method]', function(){
        jQuery('#ctpt_changed_ps').val('true');
    });

});
