<?php

namespace Ipol\Catapulto\Api\Entity\Response;

use Ipol\Catapulto\Api\BadResponseException;
use Ipol\Catapulto\Api\Entity\Response\Part\CompanyIcon\CompanyCollection;

/**
 * Class CompanyIcon
 * @package Ipol\Catapulto\Api\Entity\Response
 */
class CompanyIcon extends AbstractResponse
{
    /** @var CompanyCollection */
    protected $companies;

    /**
     * @return CompanyCollection
     */
    public function getCompanies(): CompanyCollection
    {
        return $this->companies;
    }

    /**
     * @param array $array
     *
     * @return CompanyIcon
     * @throws BadResponseException
     */
    public function setCompanies(array $array): CompanyIcon
    {
        $collection = new CompanyCollection();
        $this->companies = $collection->fillFromArray($array);
        return $this;
    }

    /**
     * @param object|array $fields
     *
     * @return CompanyIcon
     */
    public function setFields($fields)
    {
        return parent::setFields(['companies' =>$fields]); // TODO: Change the autogenerated stub
    }


}