<?php

namespace Ipol\Catapulto\Api\Entity\Response;

use Ipol\Catapulto\Api\BadResponseException;
use Ipol\Catapulto\Api\Entity\Response\Part\Geo\GeoCollection;

/**
 * Class Geo
 * @package Ipol\Catapulto\Api\Entity\Response
 */
class Geo extends AbstractResponse
{

    /** @var GeoCollection */
    protected $geo;

    /**
     * @return GeoCollection
     */
    public function getGeo(): GeoCollection
    {
        return $this->geo;
    }

    /**
     * @param array $array
     *
     * @return Geo
     * @throws BadResponseException
     */
    public function setGeo(array $array): Geo
    {
        $collection = new GeoCollection();
        $this->geo = $collection->fillFromArray($array);
        return $this;
    }

    /**
     * @param object|array $fields
     *
     * @return Geo
     */
    public function setFields($fields)
    {
        return parent::setFields(['geo' => $fields]); // TODO: Change the autogenerated stub
    }


}