<?php

namespace Ipol\Catapulto\Wordpress\DB;

class DBTools extends AbstractDB
{

    public function __construct()
    {
        parent::__construct('');
    }

    public function createTablesStructure()
    {
        $this->db->query("CREATE TABLE IF NOT EXISTS `{$this->db->get_blog_prefix()}catapulto_cartdata` (
            `wp_cart_id` int(11) NOT NULL,
            `ctpt_rate_data` int(11) NOT NULL,
            `variant` text NOT NULL,
            `updated` datetime,
            INDEX IX_CATAPULTO_DELIVERY_CARTID (`wp_cart_id`),
            INDEX IX_CATAPULTO_DELIVERY_RATE_DATA (`ctpt_rate_data`)
        ) DEFAULT CHARSET={$this->db->charset};");

        $this->db->query("CREATE TABLE IF NOT EXISTS `{$this->db->get_blog_prefix()}catapulto_operators` (
            `id` int(11) unsigned NOT NULL auto_increment,
            `operator_id` varchar(30) NOT NULL,
            `operator_display` varchar(30) NOT NULL,
            `op_enabled` varchar(1) NOT NULL DEFAULT 'Y',
            `icon` varchar(255),
            `small_icon` varchar(255),
            `png_icon` varchar(255),
            `sync_active` varchar(1) NOT NULL DEFAULT 'Y',
            `sync_last_date` datetime not null,
            `sync_hash` varchar(32) NOT NULL,
            `updated` datetime,
            PRIMARY KEY (`id`),
            INDEX IX_CATAPULTO_DELIVERY_OPERATORS_OPERATOR_ID (`operator_id`),
            INDEX IX_CATAPULTO_DELIVERY_OPERATORS_SYNC_HASH (`sync_hash`)
        ) DEFAULT CHARSET={$this->db->charset};");

        $this->db->query("CREATE TABLE IF NOT EXISTS `{$this->db->get_blog_prefix()}catapulto_orders` (
            `id` int(11) unsigned NOT NULL auto_increment,
            `order_id` int(11) unsigned NOT NULL,
            `catapulto_id` int(11) unsigned NOT NULL,
            `number` varchar(30),
            `tracking_number` varchar(50),
            `tracking_link` varchar(250),
            `key` varchar(30),
            `main_status`                     VARCHAR(30),
            `main_status_display`             VARCHAR(100),
            `pickup_day`                      VARCHAR(10),
            `delivery_day`                    VARCHAR(10),
            `price`                           DECIMAL(18, 4),
            `weight`                          DECIMAL(5, 2),
            `operator`                        VARCHAR(30),
            `sender_contact_id`               INT(11) NOT NULL,
            `sender_company`                  VARCHAR(255),
            `receiver_contact_id`             INT(11) NOT NULL,
            `receiver_locality`               VARCHAR(255),
            `receiver_name`                   VARCHAR(255),
            `receiver_company`                VARCHAR(255),
            `receiver_phone`                  VARCHAR(150),
            `receiver_email`                  VARCHAR(150),
            
            `receiver_street`                 VARCHAR(255),
            `receiver_house`                  varchar(50),
            `receiver_flat`                   varchar(50),
            
            `description`                     TEXT,
            `with_insurance`                  BOOL,
            `insurance_cost`                  DECIMAL(18, 4),
            `documents`                       TEXT,
            `last_tracking_text`              VARCHAR(150),
            `problem_text`                    VARCHAR(255),
            `is_pod`                          BOOL,
            `pod`                             VARCHAR(100),
            `sum_to_pay`                      DECIMAL(18, 4),
            `payment`                         TEXT,
            `tracking_status`                 VARCHAR(30),
            `rate_result_id`                  INT(11) NOT NULL,
            `terminal_code`                   VARCHAR(100),
            
            `comment` TEXT,
            `dlv_pay_side` tinyint(1) unsigned NOT NULL DEFAULT '0',
            
            `updated` datetime,
            PRIMARY KEY (`id`),
            INDEX IX_CATAPULTO_DELIVERY_ORDERS_ORDER_ID (`order_id`),
            INDEX IX_CATAPULTO_DELIVERY_ORDERS_CATAPULTO_ID (`catapulto_id`),
            INDEX IX_CATAPULTO_DELIVERY_ORDERS_CATAPULTO_KEY (`key`),
            INDEX IX_CATAPULTO_DELIVERY_ORDERS_CATAPULTO_NUMBER (`number`)
        ) DEFAULT CHARSET={$this->db->charset};");

    }

}
