<?php

namespace Ipol\Catapulto\Wordpress\DB;

use Ipol\Catapulto\Wordpress\CatapultoShippingMethod;

class OrdersDB extends AbstractDB
{
    const TABLENAME = 'catapulto_orders';
    protected static $stringRows = [ //varchar, text, datetime
        'number',
        'tracking_number',
        'tracking_link',
        'key',
        'main_status',
        'main_status_display',
        'pickup_day',
        'delivery_day',
        'operator',
        'sender_company',
        'receiver_locality',
        'receiver_name',
        'receiver_company',
        'receiver_phone',
        'receiver_email',
        'receiver_street',
        'receiver_house',
        'receiver_flat',
        'description',
        'documents',
        'last_tracking_text',
        'problem_text',
        'pod',
        'payment',
        'tracking_status',
        'terminal_code',
        'comment',
        'updated',
    ];

    public function __construct()
    {
        parent::__construct(self::TABLENAME);
    }

    public function getOrdersForSyncro(): array
    {
        $finalStatuses = CatapultoShippingMethod::getFinalStatuses();
        $mask = implode( ', ', array_fill( 0, count( $finalStatuses ), '%s' ) );
        $sql = $this->db->prepare("SELECT * FROM {$this->fullTableName} WHERE (`tracking_status` IS NULL) OR (`tracking_status` NOT IN ({$mask}) );", $finalStatuses);
        return $this->db->get_results($sql, 'ARRAY_A');
    }

    public function getOrdersByIDS(array $ids): array
    {
        $mask = implode( ', ', array_fill( 0, count( $ids ), '%d' ) );
        $sql = $this->db->prepare("SELECT * FROM {$this->fullTableName} WHERE (`id` IN ({$mask}) )", $ids);
        return $this->db->get_results($sql, 'ARRAY_A');
    }


}
