<?php

namespace Ipol\Catapulto\Wordpress\Tools;

class Tools
{

    public static function baseCssLoad($styleName)
    {
        $cssUrlPath = Variables::getMainPluginUrl() . 'assets/css/' . $styleName . '.css';
        wp_enqueue_style($styleName, $cssUrlPath);
    }

    /**
     * @param string $scriptName - filename from assets/js folder
     * @return void
     */
    public static function baseScriptLoad(string $scriptName)
    {
        $jsUrlPath = Variables::getMainPluginUrl() . 'assets/js/' . $scriptName . '.js';
        wp_enqueue_script( $scriptName, $jsUrlPath, [], Variables::getPliginVersion() );
    }

    public static function blocksScriptLoad(string $scriptName)
    {
        $phpFileName = Variables::getMainPluginDir() . "/build/{$scriptName}.asset.php";
        $jsUrlPath = Variables::getMainPluginUrl() . "build/{$scriptName}.js";

        $depenciesData = [
            'dependencies' => [],
            'version' => Variables::getPliginVersion(),
        ];
        if (file_exists($phpFileName) && is_readable($phpFileName)) $depenciesData = require_once $phpFileName;

        wp_enqueue_script( $scriptName, $jsUrlPath, $depenciesData['dependencies'], $depenciesData['version'] );
    }

    public static function declination(int $number, array $titles) {
        $cases = array(2, 0, 1, 1, 1, 2);
        return $number." ".$titles[($number%100>4 && $number%100<20) ? 2 : $cases[min($number%10, 5)]];
    }

    public static function phoneValidator(string $phone)
    {
        $phone = preg_replace('/\D/', '', $phone);
        if (mb_strlen($phone) == 10) $phone = '7' . $phone;
        if (mb_strlen($phone) == 11) {
            $phone = '+7' . preg_replace('/^./','',$phone);
        }
        if (mb_strlen($phone) != 12) return '';
        return $phone;
    }


}
