<?php

namespace Ipol\Catapulto\Wordpress\Tools;

class Variables
{
    private static $instance;

    private $pluginTitle = '';
    private $pluginDescription = '';

    private $mainPluginFile = '';
    private $mainPluginDir = '';
    private $mainPluginUrl = '';
    private $pliginVersion = '';


    public function __construct()
    {
        self::$instance = $this;
        $this->pluginTitle = 'Курьером или в пункт выдачи';
        $this->pluginDescription = 'Служба доставки Catapulto!';
    }

    public static function getInstance():self
    {
        if (!self::$instance) self::$instance = new self();
        return self::$instance;
    }

    public static function getPluginTitle():string
    {
        return self::getInstance()->pluginTitle;
    }

    public static function getPluginDescription():string
    {
        return self::getInstance()->pluginDescription;
    }

    public static function getMainPluginFile(): string
    {
        return self::getInstance()->mainPluginFile;
    }

    public function setMainPluginFile(string $mainPluginFile): Variables
    {
        $this->mainPluginFile = $mainPluginFile;
        return $this;
    }

    public static function getMainPluginDir(): string
    {
        return self::getInstance()->mainPluginDir;
    }

    public function setMainPluginDir(string $mainPluginDir): Variables
    {
        $this->mainPluginDir = $mainPluginDir;
        return $this;
    }

    public static function getMainPluginUrl(): string
    {
        return self::getInstance()->mainPluginUrl;
    }

    public function setMainPluginUrl(string $mainPluginUrl): Variables
    {
        $this->mainPluginUrl = $mainPluginUrl;
        return $this;
    }

    public static function getPliginVersion(): string
    {
        return self::getInstance()->pliginVersion;
    }

    public function setPliginVersion(string $pliginVersion): Variables
    {
        $this->pliginVersion = $pliginVersion;
        return $this;
    }

    public static function getIgnoredSettlementTypes(): array
    {
        return [
            'гск','снт','тер','тер. ГСК','кв-л','мкр','сквер'
        ];
    }

}
