<div class="ctpt_order_panel">
    <h3>Информация об отправлении</h3>
    <p><b>Статус заказа</b></p>
    <p>#orderStatus#</p>
    <p><b>Номер заказа CATAPULTO</b></p>
    <p>#catapultoOrderNum#</p>

    #problemText#

    <hr>
    <h4>Данные отправителя</h4>
    <p><b>Идентификатор отправителя</b></p>
    <p>#senderId#</p>
    <p><b>Город отправителя</b></p>
    <p>#senderCity#</p>

    <hr/>
    <h4>Данные получателя</h4>
    <p><b>Контактное лицо</b></p>
    <p>#receiver_name#</p>
    <p><b>Мобильный телефон</b></p>
    <p>#receiver_phone#</p>
    <p><b>Адрес электронной почты</b></p>
    <p>#receiver_email#</p>
    <p><b>Компания-получатель</b></p>
    <p>#receiver_company#</p>
    <p><b>Индекс города получения</b></p>
    <p>#receiverZip#</p>
    <p><b>Город получения</b></p>
    <p>#receiverCity#</p>
    <p><b>Улица</b></p>
    <p>#receiverStreet#</p>
    <p><b>Дом</b></p>
    <p>#receiverHouse#</p>
    <p><b>Квартира/Офис</b></p>
    <p>#receiverFlat#</p>

    <hr>
    <h4>Информация по способу доставки</h4>
    <p><b>Идентификатор способа доставки</b></p>
    <p>#variantId#</p>
    <p><b>Оператор</b></p>
    <p>#operator#</p>

    #pvzSender#
    #pvzReceiver#

    <p><b>Дата забора</b></p>
    <p>#pickupDate#</p>
    <p><b>Дата доставки</b></p>
    <p>#deliveryDate#</p>

    <p><b>Тариф оператора</b></p>
    <p>#operatorTarif#</p>

    <hr>
    <p><b>Комментарий к доставке</b></p>
    <p>#ctpt_comment#</p>

    <hr>
    <h4>Оплата</h4>
    <p><b>Стоимость доставки</b> #shippingPrice# руб</p>
    <p><b>Страхование отправления</b> #needInsurance#</p>
    <p><b>Страховая стоимость</b> #insuranceVal#</p>
    <p><b>Заказ оплачен</b> #orderPaid#</p>
    <p><b>К оплате (наложенный платеж)</b> #sumToPay#</p>
    <p><b>Доставка за счет получателя</b> #deliveryPaySide#</p>

    <hr>
    <div class="ctpt_buttons">
        <button id="ctpt_reneworder" class="button button-primary">Проверить статус</button>
        <button id="ctpt_cancelorder" class="button button-primary">Отменить заказ</button>
    </div>
</div>

<script>
    const suid = '#nonce#',
        orderId = #id#,
        catapultoOrderKey = '#catapultoOrderKey#',
        cata_order_cancelled = #ctpt_cancelled#;

    if (cata_order_cancelled) document.getElementById('ctpt_cancelorder').style.display = 'none';

    let headers = new Headers();
    headers.append('X-WP-Nonce', suid);

    const renewOrder = async function(e) {
        e.preventDefault();

        let frm = new FormData();
        frm.append('orderId', orderId);
        frm.append('catapultoOrderKey', catapultoOrderKey);

        const response= await fetch('/?rest_route=/catapultodelivery/orderrenew', {
            method: 'POST',
            headers: headers,
            body: frm,
        }), res = await response.json();

        if (typeof(res.error) == 'string') alert(res.error);
        if (res.res) window.location.reload();
    }

    const cancelOrder = async function(e) {
        e.preventDefault();
        if (confirm("Вы действительно хотите отменить отправление?\nОтменить результаты этой операции нельзя.")) {
            let frm = new FormData();
            frm.append('orderId', orderId);
            frm.append('catapultoOrderKey', catapultoOrderKey);

            const response= await fetch('/?rest_route=/catapultodelivery/ordercancel', {
                method: 'POST',
                headers: headers,
                body: frm,
            }), res = await response.json();

            if (typeof(res.error) == 'string') alert(res.error);
            if (res.res) window.location.reload();
        }
    }

    document.getElementById('ctpt_reneworder').onclick = renewOrder;
    document.getElementById('ctpt_cancelorder').onclick = cancelOrder;
</script>
